#include <SPI.h>
#include <RF24.h>

RF24 radio(9, 10); // можно использовать любые
const uint64_t readingPipe = 0xE8E8F0F0AALL; //Адрес приема
const uint64_t writingPipe = 0xE8E8F0F0ABLL; //Адрес передачи

int massive[12];
int massive1[12];
int k = 0, RX = 0;

unsigned long P1=0;
unsigned long P2=0;
int n=0;


void setup()
{
  pinMode(8, OUTPUT);
    pinMode(6, OUTPUT);
  autoadcsetup();
  Serial.begin(9600);
  
    radio.begin();                          // Включение модуля;
    radio.setChannel(20);                   // Установка канала вещания;
    radio.setRetries(15,15);                // Установка интервала и количества попыток "дозвона" до приемника;
    radio.setDataRate(RF24_250KBPS);        // Установка минимальной скорости;
    radio.setPALevel(RF24_PA_MAX);          // Установка максимальной мощности;
    radio.setAutoAck(1);                    // Установка режима подтверждения приема;
    radio.openWritingPipe(writingPipe);     // Активация данных для отправки
    radio.openReadingPipe(1,readingPipe);   // Активация данных для чтения
    radio.startListening();                 // Слушаем эфир.
}

enum {
  CH_U = 0, CH_I  = 1};


//save current voltage data
double urms = 0, urms2 = 0;
double utemp = 0;
int umoment = 0, urms1;
int umoment_old = 0;

//save current current data
double irms = 0, irms2 = 0;
double itemp = 0;
int imoment = 0, irms1;
int imoment_old = 0;

//if flag == 1 we have new data
int flag = 0;
int flag1= 0;

//number of tick from 0 to 4095
int N = 0;

//zero-cross dfetection for frequency calc
long voltage_zerocross = 0;
long voltage_zerocross_old = 0;
long signalperiod = 0;


//zero-cross detection for phase calc
long current_zerocross = 0;
long phaseperiod = 0;

float S = 0;
float P = 0, P22 = 0; 
float Q = 0;

float EP = 0;

float EQ = 0;

//current ADC channel work
int channel = CH_U, P11 = 0, frequency1 = 0, phase1 = 0, d = 0;

float frequency = 0; 

float phase = 0;

int Is, Us, Ps;


void loop()
{
 
  if (flag){
    if (RX == 1){
          radio.startListening();
          RX = 0;
    }
        digitalWrite(8, !digitalRead(8)); 
    //has new data
    frequency = 4096 / ((float)(signalperiod));
    phase = (2*3.1416) *  phaseperiod / signalperiod;
    S = urms * irms;
    urms1 = urms;
    irms1 = irms;
    P = S * cos (phase);
    Q = S * sin (phase);
    P11 = P;
    frequency1 = frequency;
    phase1 = phase;
    
    if (P > 0){
      EP += P/3600;
    }
    if (Q > 0){
      EQ += Q/3600;
    }
    flag = 0;
    
    // if ( (urms<235) & (urms > 160)){
 //  digitalWrite(6, LOW); 
 // }
 //else {     
 //           digitalWrite(6, HIGH);
 //            flag1=0;
// }
   if (urms>250){
   digitalWrite(6, HIGH);
  }
  else{
   digitalWrite(6, LOW);
  }
  
 if(d<360){
   urms2 = urms2 + urms;
   irms2 = irms2 + irms;
   P22 = P22 + P;
   d++;
 } 
 else{
 d=0;
 Us = urms2/360;
 Is = irms2/360;
 Ps = P22/360;
 urms2 = 0;
 irms2 = 0;
 P22 = 0;
 }
  
   if ( radio.available() ){                            // Упираемся и
        radio.read( &massive1, sizeof(massive1) );  // по адресу переменной in функция записывает принятые данные;

    if (massive1[0]==127){
      if (massive1[1]==111){
    SbrosTX();
    massive[0] = 127;
    massive[1] = 222;  
    massive[2] = urms1;
    massive[3] = irms1;
    massive[4] = P11;
    massive[5] = frequency1;
    massive[6] = phase1;
    massive[7] = Us;
    massive[8] = Is;
    massive[9] = Ps;
    radio.stopListening();  
    radio.write( massive, sizeof(massive));
    RX = 1;
   }
  }
 }
    Serial.print("U= ");
    Serial.println(urms);
    Serial.print("I= ");
    Serial.println(irms);
    Serial.print(" cos= ");
    Serial.println(cos(phase));
    Serial.print(" P= ");
    Serial.println(P);
    Serial.print(" Q= ");
    Serial.println(Q);
    Serial.print(" Ep= ");
    Serial.println(EP/1000);
    Serial.print(" EQ= ");
    Serial.println(EQ/1000);   
    
  }
}
int i = 255;

void autoadcsetup(){
  //set up TIMER0 to  4096Hz
  //TIMER0_OVF will be the trigger for ADC
  /*normal mode, prescaler 16
   16MHz / 64 / 30 = 8192 Hz */
  TCCR0B = (1 << CS01)|(1 << CS00);//timer frequency = clk/64
  OCR0A = 30;
  TIMSK0 = (1<<OCIE0A);
  //set ADC.
  ADMUX =  (1 << REFS0);//8-bit mode, ADC0 channel, AVVCC as ref
  ADCSRA = (1 << ADEN) | (1 << ADATE) | (1 << ADIE) | (1 << ADPS2);//TUrn ADC On, trigger enable, Interrupt enable, sysclk/16=1MHz_ADC_clk=76kHz conv freq(13ticks per conversion)
  ADCSRB = (1<< ADTS1) | (1<<ADTS0); // | (1<<MUX5);//Auto trigger source
}

ISR(TIMER0_COMPA_vect){
  TCNT0 = 0;
}


//подпрограмма измерения напряжения и тока
ISR(ADC_vect){

  if( ( UCSR0A & (1<<UDRE0)) ){
    if (channel == CH_U){
      umoment = ADCL;//calc U_RMS 
      umoment += (ADCH<<8);
      umoment = umoment - 512;
      utemp = utemp + pow((double)(umoment),2)/4096;
      channel = CH_I;//switch channel
      ADMUX |=(1<<MUX0);//to I
      //zero-crossdetect
      if ((umoment_old <= 0) && (umoment > 0)){
        voltage_zerocross = N;
        signalperiod = voltage_zerocross - voltage_zerocross_old;
        if (signalperiod < 0){
          signalperiod = 4096 - signalperiod;  
        }//calc signal period in ticks
        voltage_zerocross_old = voltage_zerocross;
      }

      umoment_old = umoment;
    }
    else{
      imoment = ADCL;//cacl I RMS 
      imoment += (ADCH<<8);
      imoment = imoment - 512;
      itemp = itemp + pow((double)(imoment),2)/4096;
      channel = CH_U;//switch channel
      ADMUX &= ~(1<<MUX0);//to U
      //zero-crossdetect
      if ((imoment_old <= 0) && (imoment > 0)){
        phaseperiod = N - voltage_zerocross;
        if (phaseperiod < 0){
          phaseperiod = 4096 - phaseperiod;
        }//calc phase period in ticks
      }
      imoment_old = imoment;
      N++;
    }
    //every 1 secvond calc RMS values
    if (N == 4095){
      //calc final result
      urms = sqrt(utemp);
      irms = sqrt(itemp)/7.55;   //102/4.31/2*100;
      N = 0;
      utemp = 0;
      itemp = 0;
      flag = 1;
      }
    }
  }

    void SbrosTX() {
    for (k=0; k<12; k++){
  massive[k] = 0;
  }
}

